﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Diagnostics;

namespace Windows_USB_Tool
{
    public partial class main : Form
    {
        public main()
        {
            InitializeComponent();
        }

        private void main_Load(object sender, EventArgs e)
        {
            showDrives();

        }
        public void showDrives()
        {
            var drives = from drive in DriveInfo.GetDrives()
                         where drive.DriveType == DriveType.Removable
                         select drive;

            comboBox1.DataSource = drives.ToList();

        }
        private void formatUSB(string type, string filesystem)
        {
            try
            {
                string driveName = comboBox1.Text;
                //Create a batch file to format a drive.
                StreamWriter tempBatch;
                tempBatch = File.CreateText(@"tempBatch.bat");
                File.SetAttributes(@"tempBatch.bat", FileAttributes.Hidden);
                tempBatch.WriteLine("format /y" + type + " /fs:" + filesystem + " /v:WinUSB " + driveName[0]+":");
                tempBatch.WriteLine("exit");
                tempBatch.Close();

                // Run batch file
                System.Diagnostics.Process Proc1 = new System.Diagnostics.Process();
                Proc1.StartInfo.FileName = @"tempBatch.bat";
                Proc1.StartInfo.UseShellExecute = false;
                Proc1.StartInfo.CreateNoWindow = true;
                Proc1.StartInfo.WindowStyle = ProcessWindowStyle.Hidden;
                Proc1.Start();
                Proc1.WaitForExit();


                // Delete the batch file
                File.Delete(@"tempBatch.bat");
            }
            catch (Exception e)
            { MessageBox.Show(e.Message.ToString()); }

        }

        private void extract_iso()
        {
            try
            {
                string driveName = comboBox1.Text;
                char delm = '"';
                //Create a batch file to extract ISO file.   
                // command : BOOTSECT.EXE /NT60 H:
                // command2 : 7z x "path" -oh:
                StreamWriter tempBatch;

                //delete the log file is exisits ....

                File.Delete(@"status.log");

                tempBatch = File.CreateText(@"tempBatch.bat");
                File.SetAttributes(@"tempBatch.bat", FileAttributes.Hidden);
                tempBatch.WriteLine("Date /t >>status.log");
                tempBatch.WriteLine("Time /t >>status.log");

                tempBatch.WriteLine("BOOTSECT.EXE /NT60 " + driveName[0] + ":" + " >>status.log");

                tempBatch.WriteLine("echo --------------------------------- >>status.log");
                tempBatch.WriteLine("echo Step3 : Extractiong ISO file..... >>status.log");
                tempBatch.WriteLine("7z x " + delm + ISO_Path.Text + delm + " -o" + driveName[0] + ":" + " >>status.log");
                tempBatch.WriteLine("Date /t >>status.log");
                tempBatch.WriteLine("Time /t >>status.log");
                tempBatch.WriteLine("echo --------------------------------- >>status.log");

                tempBatch.Close();

                // Run batch file
                System.Diagnostics.Process Proc1 = new System.Diagnostics.Process();
                Proc1.StartInfo.FileName = @"tempBatch.bat";
                Proc1.StartInfo.UseShellExecute = false;
                Proc1.StartInfo.CreateNoWindow = true;
                Proc1.StartInfo.WindowStyle = ProcessWindowStyle.Hidden;
                Proc1.Start();
                Proc1.WaitForExit();


                // Delete the batch file
                File.Delete(@"tempBatch.bat");
            }
            catch (Exception e)
            { MessageBox.Show(e.Message.ToString()); }

        }



        private void refreshDrive_Click(object sender, EventArgs e)
        {
            showDrives();
        }

        private void btnBrowse_Click(object sender, EventArgs e)
        {
            openFileDialog1.ShowDialog();
            ISO_Path.Text = openFileDialog1.FileName;

        }

        private void createUSB_Click(object sender, EventArgs e)
        {
            if (ISO_Path.TextLength > 0 && comboBox1.Text.Length>0)
            {
                StatusLbl.Visible = true;

                DialogResult result1 = MessageBox.Show("The selected USB drive  " + comboBox1.Text + "  must be formated . Are you sure you want to format this drive ? ",
             "Warning",
             MessageBoxButtons.OKCancel,
             MessageBoxIcon.Warning,
             MessageBoxDefaultButton.Button1);

                if (result1 == DialogResult.OK)
                {

                    StatusLbl.Text = "Status: Formating USB drive ...";
                    // call format fuction ...
                    formatUSB(" /q", "ntfs");
                    StatusLbl.Text = "Status: Copying files to USB... Pls. wait...";
                    // call extract iso function ..
                    extract_iso();
                    StatusLbl.Text = "Status: Done ...Task Completed";
                    MessageBox.Show("Task Completed...");
                }
                else
                { }

            }
        
        }

        

        
    }
}
